/*
 * filename: hold_buffer.h
 *
 * Developed by secunet AG
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 */

#ifndef __HOLD_BUFFER_H
#define __HOLD_BUFFER_H

#include <linux/config.h>
#include <linux/skbuff.h>
#include <linux/netdevice.h>

#include "ipsec_encap.h"


extern int ipsec_store_tx_pkg(struct eroute *er, struct sk_buff *skb,
                              struct net_device *dev);
extern int ipsec_store_rx_pkg(struct sk_buff *skb, struct net_device *dev);

extern int hb_process_makeroute(struct eroute *er);
extern int hb_process_breakroute(struct sockaddr_encap *eaddr);

extern int cleanup_hold_buffer(void);
extern int init_hold_buffer(void);
extern int flush_hold_buffers(struct eroute *er);

extern void clear_hold_eroute(struct eroute *er);

#ifdef CONFIG_IPSEC_HOLD_BUFFER_DEBUG
	#define KLIPS_HB_PRINT(format, args...) \
		printk("<HB_PRINT> " format , ## args)
#else
	#define KLIPS_HB_PRINT(format, args...) do ; while(0)
#endif

#endif
