/*
 * filename: ipsec.h
 *
 * Developed by secunet AG
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 */

#ifndef __IPSEC_H
#define __IPSEC_H

#include <linux/config.h>
#include <linux/sched.h>

#include <linux/skbuff.h>
#include <linux/ip.h>

extern char ipsec_netlink_c_version[];

#ifndef KERNEL_VERSION
#  include <linux/version.h>
#endif

#ifdef NETLINK_SOCK
extern int ipsec_callback(int proto, struct sk_buff *skb);
#else 
extern int ipsec_callback(struct sk_buff *skb);
#endif
extern void ipsec_print_ip(struct iphdr *ip);

#ifdef CONFIG_IPSEC_DEBUG

#define KLIPS_PRINT(flag, format, args...) \
	((flag) ? printk(KERN_INFO format , ## args) : 0)
#define KLIPS_PRINTMORE(flag, format, args...) \
	((flag) ? printk(format , ## args) : 0)
#define KLIPS_IP_PRINT(flag, ip) \
	((flag) ? ipsec_print_ip(ip) : 0)

extern int debug_netlink;
extern int debug_tunnel;

#else

#define KLIPS_PRINT(flag, format, args...) do ; while(0)
#define KLIPS_PRINTMORE(flag, format, args...) do ; while(0)
#define KLIPS_IP_PRINT(flag, ip) do ; while(0)

#endif

#ifdef __KERNEL__

extern unsigned int ipsec_sync_lock_hd;
extern rwlock_t ipsec_sync_lock;
extern wait_queue_head_t ipsec_sync_lock_wq;

#endif

#endif
