/*
 * filename: ipsec_cb.h
 *
 * Developed by secunet AG
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 */

#ifndef __IPSEC_CB_H
#define __IPSEC_CB_H

#include <linux/config.h>
#include <linux/netdevice.h>

typedef struct ipsec_cb_s {
	struct eroute *er;

	unsigned short hsips_hid;
	unsigned short hsips_seq;

	unsigned long stamp;

	unsigned char processed;
	unsigned char ignore:1,
	              bypass:1,
	              ike_packet:1,
	              touched:1,
	              rearrange:1,
	              direc:1,
	              pad:2;

	unsigned long orgedst;
	unsigned long orgdst;

	unsigned short hb_retries;

	struct net_device *hb_dev;
} ipsec_cb_t;

#define IPSEC_SKB_CB(skb) ((ipsec_cb_t *) (skb)->cb)

#endif
