/*
 * filename: seq.h
 *
 * Developed by secunet AG
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 */

#ifndef __IPSEC_THREAD_SEQ_H
#define __IPSEC_THREAD_SEQ_H

#include <linux/config.h>
#include <linux/spinlock.h>
#include <linux/skbuff.h>
#include <linux/interrupt.h>
#include <linux/sysctl.h>

#define IPSEC_THREAD_MAX_SEQ 0xffff
#define IPSEC_THREAD_MAX_RANGE (IPSEC_THREAD_MAX_SEQ >> 1)
#define IPSEC_THREAD_MAX_BUF (IPSEC_THREAD_MAX_SEQ >> 2)

extern int ipsec_threads_check_seq_q(void);

extern int hsips_netif_rx(struct sk_buff *skb);
extern int hsips_ip_send(struct sk_buff *skb);

extern int hsips_seq_init(void);
extern void hsips_seq_cleanup(void);

extern void hsips_inc_tx_seq(struct sk_buff *skb);
extern void hsips_inc_rx_seq(struct sk_buff *skb);

#ifdef CONFIG_IPSEC_FRAG
extern void hsips_frag_on(void);
#endif

extern atomic_t hsips_pks_in_process;

#endif
