#ifndef _AUDIT_EVENT_H
#define _AUDIT_EVENT_H

#define AU_MAX_EID				127
#define AU_MAX_ECLASS			31

#define AU_MIN_HOST_EVT			1
#define AU_MAX_HOST_EVT			73
#define AU_MIN_NET_EVT			80
#define AU_MAX_NET_EVT			89

#define AU_MIN_USER_EVT			100
#define AU_MAX_USER_EVT			127

#define	AUE_NULL				0
#define	AUE_ACCT				1
#define AUE_CAPSET				2
#define	AUE_FORK				3
#define AUE_CLONE				4
#define AUE_IOPERM				5
#define AUE_IOPL				6
#define AUE_INIT_MODULE			7
#define AUE_DELETE_MODULE		8
#define	AUE_LINK				9
#define	AUE_UNLINK				10
#define	AUE_MKNOD				11
#define	AUE_RENAME				12
#define	AUE_MKDIR				13
#define	AUE_RMDIR				14
#define	AUE_SYMLINK				15
#define	AUE_OPEN				16
#define	AUE_USELIB				17
#define	AUE_OPEN_R				18
#define	AUE_OPEN_RC				19
#define	AUE_OPEN_RT				20
#define	AUE_OPEN_RTC			21
#define	AUE_OPEN_W				22
#define	AUE_OPEN_WC				23
#define	AUE_OPEN_WT				24
#define	AUE_OPEN_WTC			25
#define	AUE_OPEN_RW				26
#define	AUE_OPEN_RWC			27
#define	AUE_OPEN_RWT			28
#define	AUE_OPEN_RWTC			29
#define	AUE_CREAT				30
#define	AUE_CHDIR				31
#define	AUE_FCHDIR				32
#define	AUE_CHMOD				33
#define	AUE_FCHMOD				34
#define	AUE_CHOWN				35
#define	AUE_FCHOWN				36
#define AUE_LCHOWN				37
#define	AUE_UTIMES				38
#define	AUE_UTIME				39
#define	AUE_CHROOT				40
#define	AUE_TRUNCATE			41
#define	AUE_FTRUNCATE			42
#define AUE_SYSLOG				43
#define	AUE_VFORK				44
#define	AUE_EXECVE				45
#define	AUE_VTRACE				46
#define	AUE_QUOTACTL			47
#define	AUE_ACCEPT				48
#define	AUE_CONNECT				49
#define	AUE_MOUNT				50
#define	AUE_SWAPON				51
#define AUE_SWAPOFF				52
#define	AUE_SETUID				53
#define	AUE_SETGID				54
#define	AUE_SETREUID			55
#define	AUE_SETREGID			56
#define	AUE_SETHOSTNAME			57
#define	AUE_SETDOMAINNAME		58
#define	AUE_SETGROUPS			59
#define AUE_SETFSUID			60
#define AUE_SETFSGID			61
#define AUE_SETRESUID			62
#define AUE_SETRESGID			63
#define	AUE_STIME				64
#define	AUE_SETTIMEOFDAY		65
#define	AUE_ADJTIME				66
#define	AUE_SYSTEMBOOT			67
#define	AUE_AUDIT				68
#define	AUE_SETAUDIT			69
#define	AUE_SETAUID				70
#define	AUE_MMAP_EXEC			71
#define	AUE_SOCKET				72
#define	AUE_X					73

#define AUE_NO_PROTO			80
#define AUE_ARP_RCV				81
#define AUE_IP_RCV				82
#define AUE_TCP_RCV				83
#define AUE_UDP_RCV				84
#define AUE_ICMP_RCV			85
#define AUE_IPIP_RCV			86
#define AUE_IGMP_RCV			87
#define AUE_IPV6_RCV			88
#define AUE_IPSEC_RCV			89

#define AUSE_MAX_EVT		15

#define AUSE_PROTO_BAD_TYPE		0

#define AUSE_ARP_BAD_SIZE		0
#define AUSE_ARP_DENY			1
#define AUSE_ARP_NOT_IP			2
#define AUSE_ARP_BAD_DEV		3
#define AUSE_ARP_NOT_ETHER		4
#define AUSE_ARP_BAD_TYPE		5
#define AUSE_ARP_BAD_DEST		6
#define AUSE_ARP_BAD_SOURCE		7
#define AUSE_ARP_NO_ROUTE		8

#define AUSE_IP_BAD_SRC			0
#define AUSE_IP_DENY			1
#define AUSE_IP_BAD_DEST		2
#define AUSE_IP_BAD_TYPE		3
#define AUSE_IP_TOBIG			4
#define AUSE_IP_BAD_PROTO		5
#define AUSE_IP_BAD_SIZE		6
#define AUSE_IP_BAD_VER			7
#define AUSE_IP_BAD_CHECK		8
#define AUSE_IP_SRR_DENY		9
#define AUSE_IP_BAD_SRR			10
#define AUSE_IP_SRR_RCV			11
#define AUSE_IP_SRR_FAILED		12

#define AUSE_TCP_BAD_DOFF		0
#define AUSE_TCP_FULL_SYNQ		1
#define AUSE_TCP_FULL_ACCEPTQ	2
#define AUSE_TCP_NO_SOCK		3
#define AUSE_TCP_BAD_FLAG		4
#define AUSE_TCP_NO_ACK			5
#define AUSE_TCP_CON_EST		6
#define AUSE_TCP_BAD_URG		7
#define AUSE_TCP_BAD_SIZE		8
#define AUSE_TCP_TO_LATE		9
#define AUSE_TCP_BAD_CHECK		10
#define AUSE_TCP_AUTH_ERR		11
#define AUSE_TCP_BAD_REQ		12
#define AUSE_TCP_WRITE_ERR		13
#define AUSE_TCP_OUT_OF_RES		14

#define AUSE_UDP_BAD_SIZE		0
#define AUSE_UDP_NO_SOCK		1
#define AUSE_UDP_BAD_CHECK		2

#define AUSE_ICMP_BAD_SIZE		0
#define AUSE_ICMP_BAD_CHECK		1
#define AUSE_ICMP_BAD_TYPE		2
#define AUSE_ICMP_REQ			3
#define AUSE_ICMP_GM6_BAD_SIZE	4
#define AUSE_ICMP_GM6_BAD_SRC	5
#define AUSE_ICMP_GM6_DENY		6
#define AUSE_ICMP_BAD_DEST		7

#define AUSE_IPIP_NO_TUN		0

#define AUSE_IGMP_BAD_SIZE		0
#define AUSE_IGMP_BAD_CHECK		1
#define AUSE_IGMP_BAD_TYPE		2
#define AUSE_IGMP_DENY			3

#define AUSE_IPV6_NO_ROUTE		0
#define AUSE_IPV6_BAD_VER		1
#define AUSE_IPV6_BAD_SIZE		3
#define AUSE_IPV6_BAD_PROTO		4
#define AUSE_IPV6_NO_DEST		5
#define AUSE_IPV6_BAD_PARAM		6
#define AUSE_IPV6_BAD_TYPE		7
#define AUSE_IPV6_TOBIG			8
#define AUSE_IPV6_BAD_ADDR		9
#define AUSE_IPV6_FRAG_ERR		10

#define AUSE_IPSEC_BAD_TYPE			0
#define AUSE_IPSEC_ESP_BAD_SIZE		1
#define AUSE_IPSEC_AH_BAD_SIZE		2
#define AUSE_IPSEC_NO_SA			3
#define AUSE_IPSEC_INBOUND_BAD_SA	4
#define AUSE_IPSEC_LARVAL_STATE		5
#define AUSE_IPSEC_DEAD_STATE		6
#define AUSE_IPSEC_HARDBYTE_TO		7
#define AUSE_IPSEC_HARDADD_TO		8
#define AUSE_IPSEC_USE_TO			9
#define AUSE_IPSEC_PKT_TO			10
#define AUSE_IPSEC_BAD_AUTH			11
#define AUSE_IPSEC_REPLAY			12
#define AUSE_IPSEC_AUTH_ERR			13
#define AUSE_IPSEC_ESP_BAD_TYPE		14
#define AUSE_IPSEC_INBOUND_NO_SA	15


#define AU_INIT_RES_EVENTMASK { \
	0, 1, 0, 0, 0, 0, 0, 1,  1, 1, 1, 1, 1, 1, 1, 1, \
	1, 1, 1, 1, 1, 1, 1, 1,  1, 1, 1, 1, 1, 1, 1, 1, \
	1, 1, 1, 1, 1, 1, 1, 1,  1, 1, 1, 0, 0, 1, 0, 1, \
	0, 0, 1, 1, 1, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, \
	0, 0, 0, 0, 0, 0, 0, 0,  1, 1, 0, 0, 0, 0, 0, 0, \
	0, 0, 0, 1, 1, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, \
	0, 0, 0, 0, 0, 1, 1, 1,  1, 1, 1, 1, 1, 1, 1, 1, \
	1, 1, 1, 1, 1, 1, 1, 1,  1, 1, 1, 1, 1, 1, 1, 1}

#define AU_EVT_CHR_SIZE 128
#define	AU_EVT_CHR {"AUE_NULL", "AUE_ACCT", "AUE_CAPSET", "AUE_FORK", \
	"AUE_CLONE", "AUE_IOPERM", "AUE_IOPL", "AUE_INIT_MODULE", \
	"AUE_DELETE_MODULE", "AUE_LINK", "AUE_UNLINK", "AUE_MKNOD", "AUE_RENAME", \
	"AUE_MKDIR", "AUE_RMDIR", "AUE_SYMLINK", "AUE_OPEN", "AUE_USELIB", \
	"AUE_OPEN_R", "AUE_OPEN_RC", "AUE_OPEN_RT", "AUE_OPEN_RTC", "AUE_OPEN_W", \
	"AUE_OPEN_WC", "AUE_OPEN_WT", "AUE_OPEN_WTC", "AUE_OPEN_RW", \
	"AUE_OPEN_RWC", "AUE_OPEN_RWT", "AUE_OPEN_RWTC", "AUE_CREAT", "AUE_CHDIR", \
	"AUE_FCHDIR", "AUE_CHMOD", "AUE_FCHMOD", "AUE_CHOWN", "AUE_FCHOWN", \
	"AUE_LCHOWN", "AUE_UTIMES", "AUE_UTIME", "AUE_CHROOT", "AUE_TRUNCATE", \
	"AUE_FTRUNCATE", "AUE_SYSLOG", "AUE_VFORK", "AUE_EXECVE", "AUE_VTRACE", \
	"AUE_QUOTACTL", "AUE_ACCEPT", "AUE_CONNECT", "AUE_MOUNT", "AUE_SWAPON", \
	"AUE_SWAPOFF", "AUE_SETUID", "AUE_SETGID", "AUE_SETREUID", "AUE_SETREGID", \
	"AUE_SETHOSTNAME", "AUE_SETDOMAINNAME", "AUE_SETGROUPS", "AUE_SETFSUID", \
	"AUE_SETFSGID", "AUE_SETRESUID", "AUE_SETRESGID", "AUE_STIME", \
	"AUE_SETTIMEOFDAY", "AUE_ADJTIME", "AUE_SYSTEMBOOT", "AUE_AUDIT", \
	"AUE_SETAUDIT", "AUE_SETAUID", "AUE_NFS_SVC", "AUE_EXPORTFS", \
	"AUE_NFS_GETFH", \
	"AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", \
	"AUE_NO_PROTO", "AUE_ARP_RCV", "AUE_TCP_RCV", "AUE_UDP_RCV", \
	"AUE_ICMP_RCV", "AUE_IPIP_RCV", "AUE_IGMP_RCV", "AUE_IPV6_RCV", \
	"AUE_IPSEC_RCV", \
	"AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", \
	"AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", \
	"AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", \
	"AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", \
	"AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X", "AUE_X"\
}



#endif
